<?php

namespace pagopa.efil\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccertamento ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccertamento
 * @subpackage Arrays
 */
class ArrayOfAccertamento extends AbstractStructArrayBase
{
    /**
     * The Accertamento
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\StructType\Accertamento[]
     */
    public $Accertamento;
    /**
     * Constructor method for ArrayOfAccertamento
     * @uses ArrayOfAccertamento::setAccertamento()
     * @param \pagopa.efil\StructType\Accertamento[] $accertamento
     */
    public function __construct(array $accertamento = array())
    {
        $this
            ->setAccertamento($accertamento);
    }
    /**
     * Get Accertamento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\StructType\Accertamento[]|null
     */
    public function getAccertamento()
    {
        return isset($this->Accertamento) ? $this->Accertamento : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccertamento method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccertamento method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccertamentoForArrayConstraintsFromSetAccertamento(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccertamentoAccertamentoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccertamentoAccertamentoItem instanceof \pagopa.efil\StructType\Accertamento) {
                $invalidValues[] = is_object($arrayOfAccertamentoAccertamentoItem) ? get_class($arrayOfAccertamentoAccertamentoItem) : sprintf('%s(%s)', gettype($arrayOfAccertamentoAccertamentoItem), var_export($arrayOfAccertamentoAccertamentoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Accertamento property can only contain items of type \pagopa.efil\StructType\Accertamento, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Accertamento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\Accertamento[] $accertamento
     * @return \pagopa.efil\ArrayType\ArrayOfAccertamento
     */
    public function setAccertamento(array $accertamento = array())
    {
        // validation for constraint: array
        if ('' !== ($accertamentoArrayErrorMessage = self::validateAccertamentoForArrayConstraintsFromSetAccertamento($accertamento))) {
            throw new \InvalidArgumentException($accertamentoArrayErrorMessage, __LINE__);
        }
        if (is_null($accertamento) || (is_array($accertamento) && empty($accertamento))) {
            unset($this->Accertamento);
        } else {
            $this->Accertamento = $accertamento;
        }
        return $this;
    }
    /**
     * Add item to Accertamento value
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\Accertamento $item
     * @return \pagopa.efil\ArrayType\ArrayOfAccertamento
     */
    public function addToAccertamento(\pagopa.efil\StructType\Accertamento $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \pagopa.efil\StructType\Accertamento) {
            throw new \InvalidArgumentException(sprintf('The Accertamento property can only contain items of type \pagopa.efil\StructType\Accertamento, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Accertamento[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \pagopa.efil\StructType\Accertamento|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \pagopa.efil\StructType\Accertamento|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \pagopa.efil\StructType\Accertamento|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \pagopa.efil\StructType\Accertamento|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \pagopa.efil\StructType\Accertamento|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Accertamento
     */
    public function getAttributeName()
    {
        return 'Accertamento';
    }
}
