<?php

namespace pagopa.efil\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEsitoDiCaricamento ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEsitoDiCaricamento
 * @subpackage Arrays
 */
class ArrayOfEsitoDiCaricamento extends AbstractStructArrayBase
{
    /**
     * The EsitoDiCaricamento
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\StructType\EsitoDiCaricamento[]
     */
    public $EsitoDiCaricamento;
    /**
     * Constructor method for ArrayOfEsitoDiCaricamento
     * @uses ArrayOfEsitoDiCaricamento::setEsitoDiCaricamento()
     * @param \pagopa.efil\StructType\EsitoDiCaricamento[] $esitoDiCaricamento
     */
    public function __construct(array $esitoDiCaricamento = array())
    {
        $this
            ->setEsitoDiCaricamento($esitoDiCaricamento);
    }
    /**
     * Get EsitoDiCaricamento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\StructType\EsitoDiCaricamento[]|null
     */
    public function getEsitoDiCaricamento()
    {
        return isset($this->EsitoDiCaricamento) ? $this->EsitoDiCaricamento : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEsitoDiCaricamento method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEsitoDiCaricamento method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEsitoDiCaricamentoForArrayConstraintsFromSetEsitoDiCaricamento(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem) {
            // validation for constraint: itemType
            if (!$arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem instanceof \pagopa.efil\StructType\EsitoDiCaricamento) {
                $invalidValues[] = is_object($arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem) ? get_class($arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem) : sprintf('%s(%s)', gettype($arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem), var_export($arrayOfEsitoDiCaricamentoEsitoDiCaricamentoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EsitoDiCaricamento property can only contain items of type \pagopa.efil\StructType\EsitoDiCaricamento, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EsitoDiCaricamento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\EsitoDiCaricamento[] $esitoDiCaricamento
     * @return \pagopa.efil\ArrayType\ArrayOfEsitoDiCaricamento
     */
    public function setEsitoDiCaricamento(array $esitoDiCaricamento = array())
    {
        // validation for constraint: array
        if ('' !== ($esitoDiCaricamentoArrayErrorMessage = self::validateEsitoDiCaricamentoForArrayConstraintsFromSetEsitoDiCaricamento($esitoDiCaricamento))) {
            throw new \InvalidArgumentException($esitoDiCaricamentoArrayErrorMessage, __LINE__);
        }
        if (is_null($esitoDiCaricamento) || (is_array($esitoDiCaricamento) && empty($esitoDiCaricamento))) {
            unset($this->EsitoDiCaricamento);
        } else {
            $this->EsitoDiCaricamento = $esitoDiCaricamento;
        }
        return $this;
    }
    /**
     * Add item to EsitoDiCaricamento value
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\EsitoDiCaricamento $item
     * @return \pagopa.efil\ArrayType\ArrayOfEsitoDiCaricamento
     */
    public function addToEsitoDiCaricamento(\pagopa.efil\StructType\EsitoDiCaricamento $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \pagopa.efil\StructType\EsitoDiCaricamento) {
            throw new \InvalidArgumentException(sprintf('The EsitoDiCaricamento property can only contain items of type \pagopa.efil\StructType\EsitoDiCaricamento, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EsitoDiCaricamento[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \pagopa.efil\StructType\EsitoDiCaricamento|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \pagopa.efil\StructType\EsitoDiCaricamento|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \pagopa.efil\StructType\EsitoDiCaricamento|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \pagopa.efil\StructType\EsitoDiCaricamento|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \pagopa.efil\StructType\EsitoDiCaricamento|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EsitoDiCaricamento
     */
    public function getAttributeName()
    {
        return 'EsitoDiCaricamento';
    }
}
