<?php

namespace pagopa.efil\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEsitoDiValidazione ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEsitoDiValidazione
 * @subpackage Arrays
 */
class ArrayOfEsitoDiValidazione extends AbstractStructArrayBase
{
    /**
     * The EsitoDiValidazione
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\StructType\EsitoDiValidazione[]
     */
    public $EsitoDiValidazione;
    /**
     * Constructor method for ArrayOfEsitoDiValidazione
     * @uses ArrayOfEsitoDiValidazione::setEsitoDiValidazione()
     * @param \pagopa.efil\StructType\EsitoDiValidazione[] $esitoDiValidazione
     */
    public function __construct(array $esitoDiValidazione = array())
    {
        $this
            ->setEsitoDiValidazione($esitoDiValidazione);
    }
    /**
     * Get EsitoDiValidazione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\StructType\EsitoDiValidazione[]|null
     */
    public function getEsitoDiValidazione()
    {
        return isset($this->EsitoDiValidazione) ? $this->EsitoDiValidazione : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEsitoDiValidazione method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEsitoDiValidazione method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEsitoDiValidazioneForArrayConstraintsFromSetEsitoDiValidazione(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEsitoDiValidazioneEsitoDiValidazioneItem) {
            // validation for constraint: itemType
            if (!$arrayOfEsitoDiValidazioneEsitoDiValidazioneItem instanceof \pagopa.efil\StructType\EsitoDiValidazione) {
                $invalidValues[] = is_object($arrayOfEsitoDiValidazioneEsitoDiValidazioneItem) ? get_class($arrayOfEsitoDiValidazioneEsitoDiValidazioneItem) : sprintf('%s(%s)', gettype($arrayOfEsitoDiValidazioneEsitoDiValidazioneItem), var_export($arrayOfEsitoDiValidazioneEsitoDiValidazioneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EsitoDiValidazione property can only contain items of type \pagopa.efil\StructType\EsitoDiValidazione, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EsitoDiValidazione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\EsitoDiValidazione[] $esitoDiValidazione
     * @return \pagopa.efil\ArrayType\ArrayOfEsitoDiValidazione
     */
    public function setEsitoDiValidazione(array $esitoDiValidazione = array())
    {
        // validation for constraint: array
        if ('' !== ($esitoDiValidazioneArrayErrorMessage = self::validateEsitoDiValidazioneForArrayConstraintsFromSetEsitoDiValidazione($esitoDiValidazione))) {
            throw new \InvalidArgumentException($esitoDiValidazioneArrayErrorMessage, __LINE__);
        }
        if (is_null($esitoDiValidazione) || (is_array($esitoDiValidazione) && empty($esitoDiValidazione))) {
            unset($this->EsitoDiValidazione);
        } else {
            $this->EsitoDiValidazione = $esitoDiValidazione;
        }
        return $this;
    }
    /**
     * Add item to EsitoDiValidazione value
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\EsitoDiValidazione $item
     * @return \pagopa.efil\ArrayType\ArrayOfEsitoDiValidazione
     */
    public function addToEsitoDiValidazione(\pagopa.efil\StructType\EsitoDiValidazione $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \pagopa.efil\StructType\EsitoDiValidazione) {
            throw new \InvalidArgumentException(sprintf('The EsitoDiValidazione property can only contain items of type \pagopa.efil\StructType\EsitoDiValidazione, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EsitoDiValidazione[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \pagopa.efil\StructType\EsitoDiValidazione|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \pagopa.efil\StructType\EsitoDiValidazione|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \pagopa.efil\StructType\EsitoDiValidazione|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \pagopa.efil\StructType\EsitoDiValidazione|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \pagopa.efil\StructType\EsitoDiValidazione|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EsitoDiValidazione
     */
    public function getAttributeName()
    {
        return 'EsitoDiValidazione';
    }
}
