<?php

namespace pagopa.efil\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfParametroPosizione ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfParametroPosizione
 * @subpackage Arrays
 */
class ArrayOfParametroPosizione extends AbstractStructArrayBase
{
    /**
     * The ParametroPosizione
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\StructType\ParametroPosizione[]
     */
    public $ParametroPosizione;
    /**
     * Constructor method for ArrayOfParametroPosizione
     * @uses ArrayOfParametroPosizione::setParametroPosizione()
     * @param \pagopa.efil\StructType\ParametroPosizione[] $parametroPosizione
     */
    public function __construct(array $parametroPosizione = array())
    {
        $this
            ->setParametroPosizione($parametroPosizione);
    }
    /**
     * Get ParametroPosizione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\StructType\ParametroPosizione[]|null
     */
    public function getParametroPosizione()
    {
        return isset($this->ParametroPosizione) ? $this->ParametroPosizione : null;
    }
    /**
     * This method is responsible for validating the values passed to the setParametroPosizione method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParametroPosizione method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParametroPosizioneForArrayConstraintsFromSetParametroPosizione(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfParametroPosizioneParametroPosizioneItem) {
            // validation for constraint: itemType
            if (!$arrayOfParametroPosizioneParametroPosizioneItem instanceof \pagopa.efil\StructType\ParametroPosizione) {
                $invalidValues[] = is_object($arrayOfParametroPosizioneParametroPosizioneItem) ? get_class($arrayOfParametroPosizioneParametroPosizioneItem) : sprintf('%s(%s)', gettype($arrayOfParametroPosizioneParametroPosizioneItem), var_export($arrayOfParametroPosizioneParametroPosizioneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ParametroPosizione property can only contain items of type \pagopa.efil\StructType\ParametroPosizione, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ParametroPosizione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\ParametroPosizione[] $parametroPosizione
     * @return \pagopa.efil\ArrayType\ArrayOfParametroPosizione
     */
    public function setParametroPosizione(array $parametroPosizione = array())
    {
        // validation for constraint: array
        if ('' !== ($parametroPosizioneArrayErrorMessage = self::validateParametroPosizioneForArrayConstraintsFromSetParametroPosizione($parametroPosizione))) {
            throw new \InvalidArgumentException($parametroPosizioneArrayErrorMessage, __LINE__);
        }
        if (is_null($parametroPosizione) || (is_array($parametroPosizione) && empty($parametroPosizione))) {
            unset($this->ParametroPosizione);
        } else {
            $this->ParametroPosizione = $parametroPosizione;
        }
        return $this;
    }
    /**
     * Add item to ParametroPosizione value
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\ParametroPosizione $item
     * @return \pagopa.efil\ArrayType\ArrayOfParametroPosizione
     */
    public function addToParametroPosizione(\pagopa.efil\StructType\ParametroPosizione $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \pagopa.efil\StructType\ParametroPosizione) {
            throw new \InvalidArgumentException(sprintf('The ParametroPosizione property can only contain items of type \pagopa.efil\StructType\ParametroPosizione, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ParametroPosizione[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \pagopa.efil\StructType\ParametroPosizione|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \pagopa.efil\StructType\ParametroPosizione|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \pagopa.efil\StructType\ParametroPosizione|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \pagopa.efil\StructType\ParametroPosizione|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \pagopa.efil\StructType\ParametroPosizione|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ParametroPosizione
     */
    public function getAttributeName()
    {
        return 'ParametroPosizione';
    }
}
