<?php

namespace pagopa.efil\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPosizione ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPosizione
 * @subpackage Arrays
 */
class ArrayOfPosizione extends AbstractStructArrayBase
{
    /**
     * The Posizione
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\StructType\Posizione[]
     */
    public $Posizione;
    /**
     * Constructor method for ArrayOfPosizione
     * @uses ArrayOfPosizione::setPosizione()
     * @param \pagopa.efil\StructType\Posizione[] $posizione
     */
    public function __construct(array $posizione = array())
    {
        $this
            ->setPosizione($posizione);
    }
    /**
     * Get Posizione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\StructType\Posizione[]|null
     */
    public function getPosizione()
    {
        return isset($this->Posizione) ? $this->Posizione : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPosizione method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPosizione method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePosizioneForArrayConstraintsFromSetPosizione(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPosizionePosizioneItem) {
            // validation for constraint: itemType
            if (!$arrayOfPosizionePosizioneItem instanceof \pagopa.efil\StructType\Posizione) {
                $invalidValues[] = is_object($arrayOfPosizionePosizioneItem) ? get_class($arrayOfPosizionePosizioneItem) : sprintf('%s(%s)', gettype($arrayOfPosizionePosizioneItem), var_export($arrayOfPosizionePosizioneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Posizione property can only contain items of type \pagopa.efil\StructType\Posizione, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Posizione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\Posizione[] $posizione
     * @return \pagopa.efil\ArrayType\ArrayOfPosizione
     */
    public function setPosizione(array $posizione = array())
    {
        // validation for constraint: array
        if ('' !== ($posizioneArrayErrorMessage = self::validatePosizioneForArrayConstraintsFromSetPosizione($posizione))) {
            throw new \InvalidArgumentException($posizioneArrayErrorMessage, __LINE__);
        }
        if (is_null($posizione) || (is_array($posizione) && empty($posizione))) {
            unset($this->Posizione);
        } else {
            $this->Posizione = $posizione;
        }
        return $this;
    }
    /**
     * Add item to Posizione value
     * @throws \InvalidArgumentException
     * @param \pagopa.efil\StructType\Posizione $item
     * @return \pagopa.efil\ArrayType\ArrayOfPosizione
     */
    public function addToPosizione(\pagopa.efil\StructType\Posizione $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \pagopa.efil\StructType\Posizione) {
            throw new \InvalidArgumentException(sprintf('The Posizione property can only contain items of type \pagopa.efil\StructType\Posizione, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Posizione[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \pagopa.efil\StructType\Posizione|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \pagopa.efil\StructType\Posizione|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \pagopa.efil\StructType\Posizione|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \pagopa.efil\StructType\Posizione|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \pagopa.efil\StructType\Posizione|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Posizione
     */
    public function getAttributeName()
    {
        return 'Posizione';
    }
}
