<?php

namespace pagopa.efil;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CaricaPosizione' => '\\pagopa.efil\\StructType\\CaricaPosizione',
            'RichiestaCaricaPosizione' => '\\pagopa.efil\\StructType\\RichiestaCaricaPosizione',
            'FeedAuthenticatedRequestBase' => '\\pagopa.efil\\StructType\\FeedAuthenticatedRequestBase',
            'RichiestaCaricaPosizioni' => '\\pagopa.efil\\StructType\\RichiestaCaricaPosizioni',
            'ArrayOfPosizione' => '\\pagopa.efil\\ArrayType\\ArrayOfPosizione',
            'Posizione' => '\\pagopa.efil\\StructType\\Posizione',
            'ArrayOfAccertamento' => '\\pagopa.efil\\ArrayType\\ArrayOfAccertamento',
            'Accertamento' => '\\pagopa.efil\\StructType\\Accertamento',
            'Creditore' => '\\pagopa.efil\\StructType\\Creditore',
            'Debitore' => '\\pagopa.efil\\StructType\\Debitore',
            'Nazione' => '\\pagopa.efil\\StructType\\Nazione',
            'ArrayOfParametroPosizione' => '\\pagopa.efil\\ArrayType\\ArrayOfParametroPosizione',
            'ParametroPosizione' => '\\pagopa.efil\\StructType\\ParametroPosizione',
            'CaricaPosizioneResponse' => '\\pagopa.efil\\StructType\\CaricaPosizioneResponse',
            'RispostaCaricaPosizione' => '\\pagopa.efil\\StructType\\RispostaCaricaPosizione',
            'EsitoDiCaricamento' => '\\pagopa.efil\\StructType\\EsitoDiCaricamento',
            'ArrayOfErroreDiValidazionePosizione' => '\\pagopa.efil\\ArrayType\\ArrayOfErroreDiValidazionePosizione',
            'ErroreDiValidazionePosizione' => '\\pagopa.efil\\StructType\\ErroreDiValidazionePosizione',
            'SoapFaultOperazioneProibita' => '\\pagopa.efil\\StructType\\SoapFaultOperazioneProibita',
            'SoapFault' => '\\pagopa.efil\\StructType\\SoapFault',
            'SoapFaultErroreInterno' => '\\pagopa.efil\\StructType\\SoapFaultErroreInterno',
            'SoapFaultErroreEasyPA' => '\\pagopa.efil\\StructType\\SoapFaultErroreEasyPA',
            'CaricaPosizioneConEsitoArricchito' => '\\pagopa.efil\\StructType\\CaricaPosizioneConEsitoArricchito',
            'CaricaPosizioneConEsitoArricchitoResponse' => '\\pagopa.efil\\StructType\\CaricaPosizioneConEsitoArricchitoResponse',
            'RispostaCaricaPosizioneConEsitoArricchito' => '\\pagopa.efil\\StructType\\RispostaCaricaPosizioneConEsitoArricchito',
            'EsitoDiCaricamentoArricchito' => '\\pagopa.efil\\StructType\\EsitoDiCaricamentoArricchito',
            'CaricaPosizioni' => '\\pagopa.efil\\StructType\\CaricaPosizioni',
            'CaricaPosizioniResponse' => '\\pagopa.efil\\StructType\\CaricaPosizioniResponse',
            'RispostaCaricaPosizioni' => '\\pagopa.efil\\StructType\\RispostaCaricaPosizioni',
            'ArrayOfEsitoDiCaricamento' => '\\pagopa.efil\\ArrayType\\ArrayOfEsitoDiCaricamento',
            'ValidaPosizioni' => '\\pagopa.efil\\StructType\\ValidaPosizioni',
            'RichiestaValidaPosizioni' => '\\pagopa.efil\\StructType\\RichiestaValidaPosizioni',
            'ValidaPosizioniResponse' => '\\pagopa.efil\\StructType\\ValidaPosizioniResponse',
            'RispostaValidaPosizioni' => '\\pagopa.efil\\StructType\\RispostaValidaPosizioni',
            'ArrayOfEsitoDiValidazione' => '\\pagopa.efil\\ArrayType\\ArrayOfEsitoDiValidazione',
            'EsitoDiValidazione' => '\\pagopa.efil\\StructType\\EsitoDiValidazione',
            'RettificaPosizione' => '\\pagopa.efil\\StructType\\RettificaPosizione',
            'RichiestaRettificaPosizione' => '\\pagopa.efil\\StructType\\RichiestaRettificaPosizione',
            'RettificaPosizioneResponse' => '\\pagopa.efil\\StructType\\RettificaPosizioneResponse',
            'RispostaRettificaPosizione' => '\\pagopa.efil\\StructType\\RispostaRettificaPosizione',
            'RimuoviPosizione' => '\\pagopa.efil\\StructType\\RimuoviPosizione',
            'RichiestaRimuoviPosizione' => '\\pagopa.efil\\StructType\\RichiestaRimuoviPosizione',
            'RimuoviPosizioneResponse' => '\\pagopa.efil\\StructType\\RimuoviPosizioneResponse',
            'RispostaRimuoviPosizione' => '\\pagopa.efil\\StructType\\RispostaRimuoviPosizione',
            'PosizionePagata' => '\\pagopa.efil\\StructType\\PosizionePagata',
            'DatiPagamento' => '\\pagopa.efil\\StructType\\DatiPagamento',
            'RispostaCaricaPosizionePagataMessageBody' => '\\pagopa.efil\\StructType\\RispostaCaricaPosizionePagataMessageBody',
            'Servizio' => '\\pagopa.efil\\StructType\\Servizio',
            'ArrayOfRipartizioneDiImportoInAccertamento' => '\\pagopa.efil\\ArrayType\\ArrayOfRipartizioneDiImportoInAccertamento',
            'RipartizioneDiImportoInAccertamento' => '\\pagopa.efil\\StructType\\RipartizioneDiImportoInAccertamento',
        );
    }
}
