<?php

namespace pagopa.efil\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RispostaCaricaPosizionePagataMessageBody StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RispostaCaricaPosizionePagataMessageBody
 * @subpackage Structs
 */
class RispostaCaricaPosizionePagataMessageBody extends AbstractStructBase
{
    /**
     * The CodiceRiferimentoCreditore
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodiceRiferimentoCreditore;
    /**
     * The ErroriDiValidazione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione
     */
    public $ErroriDiValidazione;
    /**
     * The Esito
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Esito;
    /**
     * The IdentificativoPosizione
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $IdentificativoPosizione;
    /**
     * The TipoRiferimentoCreditore
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TipoRiferimentoCreditore;
    /**
     * Constructor method for RispostaCaricaPosizionePagataMessageBody
     * @uses RispostaCaricaPosizionePagataMessageBody::setCodiceRiferimentoCreditore()
     * @uses RispostaCaricaPosizionePagataMessageBody::setErroriDiValidazione()
     * @uses RispostaCaricaPosizionePagataMessageBody::setEsito()
     * @uses RispostaCaricaPosizionePagataMessageBody::setIdentificativoPosizione()
     * @uses RispostaCaricaPosizionePagataMessageBody::setTipoRiferimentoCreditore()
     * @param string $codiceRiferimentoCreditore
     * @param \pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione $erroriDiValidazione
     * @param string $esito
     * @param string $identificativoPosizione
     * @param string $tipoRiferimentoCreditore
     */
    public function __construct($codiceRiferimentoCreditore = null, \pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione $erroriDiValidazione = null, $esito = null, $identificativoPosizione = null, $tipoRiferimentoCreditore = null)
    {
        $this
            ->setCodiceRiferimentoCreditore($codiceRiferimentoCreditore)
            ->setErroriDiValidazione($erroriDiValidazione)
            ->setEsito($esito)
            ->setIdentificativoPosizione($identificativoPosizione)
            ->setTipoRiferimentoCreditore($tipoRiferimentoCreditore);
    }
    /**
     * Get CodiceRiferimentoCreditore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodiceRiferimentoCreditore()
    {
        return isset($this->CodiceRiferimentoCreditore) ? $this->CodiceRiferimentoCreditore : null;
    }
    /**
     * Set CodiceRiferimentoCreditore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codiceRiferimentoCreditore
     * @return \pagopa.efil\StructType\RispostaCaricaPosizionePagataMessageBody
     */
    public function setCodiceRiferimentoCreditore($codiceRiferimentoCreditore = null)
    {
        // validation for constraint: string
        if (!is_null($codiceRiferimentoCreditore) && !is_string($codiceRiferimentoCreditore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codiceRiferimentoCreditore, true), gettype($codiceRiferimentoCreditore)), __LINE__);
        }
        if (is_null($codiceRiferimentoCreditore) || (is_array($codiceRiferimentoCreditore) && empty($codiceRiferimentoCreditore))) {
            unset($this->CodiceRiferimentoCreditore);
        } else {
            $this->CodiceRiferimentoCreditore = $codiceRiferimentoCreditore;
        }
        return $this;
    }
    /**
     * Get ErroriDiValidazione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione|null
     */
    public function getErroriDiValidazione()
    {
        return isset($this->ErroriDiValidazione) ? $this->ErroriDiValidazione : null;
    }
    /**
     * Set ErroriDiValidazione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione $erroriDiValidazione
     * @return \pagopa.efil\StructType\RispostaCaricaPosizionePagataMessageBody
     */
    public function setErroriDiValidazione(\pagopa.efil\ArrayType\ArrayOfErroreDiValidazionePosizione $erroriDiValidazione = null)
    {
        if (is_null($erroriDiValidazione) || (is_array($erroriDiValidazione) && empty($erroriDiValidazione))) {
            unset($this->ErroriDiValidazione);
        } else {
            $this->ErroriDiValidazione = $erroriDiValidazione;
        }
        return $this;
    }
    /**
     * Get Esito value
     * @return string|null
     */
    public function getEsito()
    {
        return $this->Esito;
    }
    /**
     * Set Esito value
     * @uses \pagopa.efil\EnumType\Esito::valueIsValid()
     * @uses \pagopa.efil\EnumType\Esito::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $esito
     * @return \pagopa.efil\StructType\RispostaCaricaPosizionePagataMessageBody
     */
    public function setEsito($esito = null)
    {
        // validation for constraint: enumeration
        if (!\pagopa.efil\EnumType\Esito::valueIsValid($esito)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \pagopa.efil\EnumType\Esito', is_array($esito) ? implode(', ', $esito) : var_export($esito, true), implode(', ', \pagopa.efil\EnumType\Esito::getValidValues())), __LINE__);
        }
        $this->Esito = $esito;
        return $this;
    }
    /**
     * Get IdentificativoPosizione value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdentificativoPosizione()
    {
        return isset($this->IdentificativoPosizione) ? $this->IdentificativoPosizione : null;
    }
    /**
     * Set IdentificativoPosizione value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $identificativoPosizione
     * @return \pagopa.efil\StructType\RispostaCaricaPosizionePagataMessageBody
     */
    public function setIdentificativoPosizione($identificativoPosizione = null)
    {
        // validation for constraint: string
        if (!is_null($identificativoPosizione) && !is_string($identificativoPosizione)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificativoPosizione, true), gettype($identificativoPosizione)), __LINE__);
        }
        if (is_null($identificativoPosizione) || (is_array($identificativoPosizione) && empty($identificativoPosizione))) {
            unset($this->IdentificativoPosizione);
        } else {
            $this->IdentificativoPosizione = $identificativoPosizione;
        }
        return $this;
    }
    /**
     * Get TipoRiferimentoCreditore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTipoRiferimentoCreditore()
    {
        return isset($this->TipoRiferimentoCreditore) ? $this->TipoRiferimentoCreditore : null;
    }
    /**
     * Set TipoRiferimentoCreditore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $tipoRiferimentoCreditore
     * @return \pagopa.efil\StructType\RispostaCaricaPosizionePagataMessageBody
     */
    public function setTipoRiferimentoCreditore($tipoRiferimentoCreditore = null)
    {
        // validation for constraint: string
        if (!is_null($tipoRiferimentoCreditore) && !is_string($tipoRiferimentoCreditore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoRiferimentoCreditore, true), gettype($tipoRiferimentoCreditore)), __LINE__);
        }
        if (is_null($tipoRiferimentoCreditore) || (is_array($tipoRiferimentoCreditore) && empty($tipoRiferimentoCreditore))) {
            unset($this->TipoRiferimentoCreditore);
        } else {
            $this->TipoRiferimentoCreditore = $tipoRiferimentoCreditore;
        }
        return $this;
    }
}
